﻿
using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace RazorTemplatesAndValidationSummary.Models
{
  public class Event : IValidatableObject
  {
    [Required]
    public string Name
    { get; set; }

    public DateTime Date
    { get; set; }

    [Required]
    public string Place
    { get; set; }

    public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
    {
      var results = new List<ValidationResult>();

      if ((Date - DateTime.Now).Days < 1)
      {
        results.Add(new ValidationResult("You can host an event atleast one day after the current time."));
      }

      if (!new[] { "bangalore", "chennai", "hyderabad", "cochin" }.Contains(Place.ToLower().Trim()))
      {
        results.Add(new ValidationResult("You can host an event only in bangalore, chennai, hyderabad or cochin."));
      }

      return results;
    }
  }
}